export declare const pathResolve: {
    "1": string[][];
    "2": (string | string[])[][];
    "3": (string | string[])[][];
    "4": (string | string[])[][];
    "5": (string | string[])[][];
    "6": (string | string[])[][];
};
export declare const queryParams: {
    "/": {
        get: never[];
    };
    "/users/@me": {
        get: never[];
    };
    "/users/{target}": {
        get: never[];
        patch: never[];
    };
    "/users/{target}/flags": {
        get: never[];
    };
    "/users/@me/username": {
        patch: never[];
    };
    "/users/{target}/default_avatar": {
        get: never[];
    };
    "/users/{target}/profile": {
        get: never[];
    };
    "/users/dms": {
        get: never[];
    };
    "/users/{target}/dm": {
        get: never[];
    };
    "/users/{target}/mutual": {
        get: never[];
    };
    "/users/{target}/friend": {
        put: never[];
        delete: never[];
    };
    "/users/{target}/block": {
        put: never[];
        delete: never[];
    };
    "/users/friend": {
        post: never[];
    };
    "/bots/create": {
        post: never[];
    };
    "/bots/{target}/invite": {
        get: never[];
        post: never[];
    };
    "/bots/{bot}": {
        get: never[];
    };
    "/bots/@me": {
        get: never[];
    };
    "/bots/{target}": {
        delete: never[];
        patch: never[];
    };
    "/channels/{target}/ack/{message}": {
        put: never[];
    };
    "/channels/{target}": {
        get: never[];
        delete: string[];
        patch: never[];
    };
    "/channels/{target}/members": {
        get: never[];
    };
    "/channels/{target}/invites": {
        post: never[];
    };
    "/channels/{target}/messages": {
        get: string[];
        post: never[];
    };
    "/channels/{target}/search": {
        post: never[];
    };
    "/channels/{target}/messages/{msg}/pin": {
        post: never[];
        delete: never[];
    };
    "/channels/{target}/messages/{msg}": {
        get: never[];
        delete: never[];
        patch: never[];
    };
    "/channels/{target}/messages/bulk": {
        delete: never[];
    };
    "/channels/create": {
        post: never[];
    };
    "/channels/{group_id}/recipients/{member_id}": {
        put: never[];
    };
    "/channels/{target}/recipients/{member}": {
        delete: never[];
    };
    "/channels/{target}/join_call": {
        post: never[];
    };
    "/channels/{target}/permissions/{role_id}": {
        put: never[];
    };
    "/channels/{target}/permissions/default": {
        put: never[];
    };
    "/channels/{target}/messages/{msg}/reactions/{emoji}": {
        put: never[];
        delete: string[];
    };
    "/channels/{target}/messages/{msg}/reactions": {
        delete: never[];
    };
    "/channels/{target}/webhooks": {
        post: never[];
    };
    "/channels/{channel_id}/webhooks": {
        get: never[];
    };
    "/servers/create": {
        post: never[];
    };
    "/servers/{target}": {
        get: string[];
        delete: string[];
        patch: never[];
    };
    "/servers/{target}/ack": {
        put: never[];
    };
    "/servers/{server}/channels": {
        post: never[];
    };
    "/servers/{target}/members": {
        get: string[];
    };
    "/servers/{target}/members/{member}": {
        get: string[];
        delete: never[];
    };
    "/servers/{server}/members/{member}": {
        patch: never[];
    };
    "/servers/{target}/members_experimental_query": {
        get: string[];
    };
    "/servers/{server}/bans/{target}": {
        put: never[];
        delete: never[];
    };
    "/servers/{target}/bans": {
        get: never[];
    };
    "/servers/{target}/invites": {
        get: never[];
    };
    "/servers/{target}/roles": {
        post: never[];
    };
    "/servers/{target}/roles/{role_id}": {
        get: never[];
        delete: never[];
        patch: never[];
    };
    "/servers/{target}/permissions/{role_id}": {
        put: never[];
    };
    "/servers/{target}/permissions/default": {
        put: never[];
    };
    "/servers/{target}/emojis": {
        get: never[];
    };
    "/servers/{target}/roles/ranks": {
        patch: never[];
    };
    "/invites/{target}": {
        get: never[];
        post: never[];
        delete: never[];
    };
    "/custom/emoji/{id}": {
        put: never[];
    };
    "/custom/emoji/{emoji_id}": {
        get: never[];
        delete: never[];
    };
    "/safety/report": {
        post: never[];
    };
    "/auth/account/create": {
        post: never[];
    };
    "/auth/account/reverify": {
        post: never[];
    };
    "/auth/account/delete": {
        put: never[];
        post: never[];
    };
    "/auth/account/": {
        get: never[];
    };
    "/auth/account/disable": {
        post: never[];
    };
    "/auth/account/change/password": {
        patch: never[];
    };
    "/auth/account/change/email": {
        patch: never[];
    };
    "/auth/account/verify/{code}": {
        post: never[];
    };
    "/auth/account/reset_password": {
        post: never[];
        patch: never[];
    };
    "/auth/session/login": {
        post: never[];
    };
    "/auth/session/logout": {
        post: never[];
    };
    "/auth/session/all": {
        get: never[];
        delete: string[];
    };
    "/auth/session/{id}": {
        delete: never[];
        patch: never[];
    };
    "/auth/mfa/ticket": {
        put: never[];
    };
    "/auth/mfa/": {
        get: never[];
    };
    "/auth/mfa/recovery": {
        post: never[];
        patch: never[];
    };
    "/auth/mfa/methods": {
        get: never[];
    };
    "/auth/mfa/totp": {
        put: never[];
        post: never[];
        delete: never[];
    };
    "/onboard/hello": {
        get: never[];
    };
    "/onboard/complete": {
        post: never[];
    };
    "/policy/acknowledge": {
        post: never[];
    };
    "/push/subscribe": {
        post: never[];
    };
    "/push/unsubscribe": {
        post: never[];
    };
    "/sync/settings/fetch": {
        post: never[];
    };
    "/sync/settings/set": {
        post: string[];
    };
    "/sync/unreads": {
        get: never[];
    };
    "/webhooks/{webhook_id}/{token}": {
        get: never[];
        post: never[];
        delete: never[];
        patch: never[];
    };
    "/webhooks/{webhook_id}": {
        get: never[];
        delete: never[];
        patch: never[];
    };
    "/webhooks/{webhook_id}/{token}/github": {
        post: never[];
    };
};
//# sourceMappingURL=params.d.ts.map